/**
 *	Author: JCloudYu
 *	Create: 2019/10/19
**/
import crypto from "crypto";
import assert from "assert";
import {
	Base64Encode, Base64Decode,
	Base64URLEncode, Base64URLDecode,
	Base64SortEncode, Base64SortDecode,
	Base64URLSortEncode, Base64URLSortDecode
} from "../base64.esm.js";


init_context('base64', ()=>{
	const truth_raw = Buffer.alloc(61);
	truth_raw.set(crypto.randomBytes(61));
	
	
	
	test_group( "Testing Base64 Encode / Decode", ()=>{
		const result = Buffer.from(Base64Decode(Base64Encode(truth_raw.buffer)));
		assert(result.compare(truth_raw) === 0);
	});
	
	test_group( "Testing Base64URL Encode / Decode", ()=>{
		const result = Buffer.from(Base64URLDecode(Base64URLEncode(truth_raw.buffer)));
		assert(result.compare(truth_raw) === 0);
	});
	
	test_group( "Testing Base64Sort Encode / Decode", ()=>{
		const result = Buffer.from(Base64SortDecode(Base64SortEncode(truth_raw.buffer)));
		assert(result.compare(truth_raw) === 0);
	});
	
	test_group( "Testing Base64URLSort Encode / Decode", ()=>{
		const result = Buffer.from(Base64URLSortDecode(Base64URLSortEncode(truth_raw.buffer)));
		assert(result.compare(truth_raw) === 0);
	});
});
